  function B = IJPEG(A)
% A is mxn JPEG-compressed matrix and B is is JPEG decompressed analog.
% Assumes that both m and n are divisible by 8.
[m,n] = size(A);
m1 = m/8;
n1 = n/8;
% Obtain the 8x8 quantization matrix...
Q = Quant();
% Regarding A as block matrix with 8x8 blocks, apply Q to each block...
B = round(A.*kron(ones(m1,n1),Q));
% Now regard this matrix as an (m/8)-by-n block matrix whose blocks are column 8-vectors.
% Assemble these vectors into an 8-by-mn/8) array..
B = reshape(B,8,m*n/8);
% Apply the IDCT to each of these vectors...
B = IDCT8(B);
% Here is A with each of its length-8 subcolumns updated by the IDCT..
B = reshape(B,m,n);
% The rows of this matrix are now columns of this..
B = B';
% Regard this matrix as an 8-by-mn/8 block matrix whose blocks are column
% 8-vectors...
B = reshape(B,8,m*n/8);
% Apply the IDCT to each of these vectors...
B = IDCT8(B);
% Here is the final picture matrix transposed...
B = reshape(B,n,m);
% All done...
B = B';
